import r from "../Xhttp.ts";
import { USER_URL as s } from "../url.ts";
import n from "../../../node_modules/crypto-js/md5.ts";
const E = {
  // 修改用户密码接口
  async userModifyPassword({ confirmPassword: t, newPassword: e, oldPassword: a }) {
    return e = n(e).toString(), a = n(a).toString(), t = n(t).toString(), await r.post("user/modifyPassword", {
      confirmPassword: t,
      newPassword: e,
      oldPassword: a
    });
  },
  // 用户编号查询
  async queryUserInfo(t) {
    return await r.get(`user/${t}`);
  },
  async batchCreateUser({ code: t, roleId: e }) {
    return await r.post("organUser/batchCreate", { code: t, roles: [e] });
  },
  // !上面是旧的接口，需要删除
  /**
   * 根据条件进行分页查询用户列表
   */
  async queryUserList({
    page: t,
    backRole: e = !0,
    backOrganization: a = !0,
    username: u,
    nickname: i,
    size: o
  }) {
    return r.get(s.LIST, {
      page: t,
      backRole: e,
      backOrganization: a,
      username: u,
      nickname: i,
      size: o
    });
  },
  async getUserList(t) {
    return await r.get(s.LIST, t);
  },
  // 保存用户接口
  async addUser(t) {
    return t.password = n(t.password).toString(), await r.post(s.ADD_USER, t);
  },
  // 更新用户接口
  async updateUser(t) {
    return await r.put(s.MODIFY_USER(t._id), t);
  },
  // 批量停用用户账号接口
  async suspendUser(t) {
    return await r.post(s.SUSPEND_USER(t), {});
  },
  // 批量启用用户账号接口
  async resumeUser(t) {
    return await r.post(s.RESUME_USER(t), {});
  },
  // 批量重置用户密码接口
  async resetUserPasswords(t) {
    const { userIds: e } = t;
    if (e.length === 0)
      throw new Error("userIds不能为空");
    return await r.post(s.RESET_PASSWORD, t);
  },
  // 根据用户编号批量删除用户接口
  async deleteUser(t) {
    return await r.delete(s.DELETE_USER(t));
  }
};
export {
  E as default
};
