import { defineComponent as be, mergeModels as J, useModel as Q, computed as _e, resolveComponent as g, openBlock as o, createElementBlock as i, createElementVNode as z, Fragment as m, renderList as B, unref as e, createBlock as s, withCtx as a, createCommentVNode as k, createTextVNode as d, toDisplayString as p, createVNode as y, renderSlot as Se, normalizeStyle as b, withDirectives as he, vShow as ve } from "vue";
import C from "../SvgIcon/index.vue.ts";
import { isSlotField as we, isFormatField as Oe, isDictField as ze, tableStatic as U } from "./hooks/index.ts";
import qe from "./hooks/useColumns.ts";
import Ne from "./hooks/useDict.ts";
import Fe from "./hooks/useOperator.ts";
import Ae from "./hooks/useFormValue.ts";
import De from "./hooks/useAttribute.ts";
const Ve = { class: "gt-table" }, $e = { class: "header-wrapper" }, Me = { class: "btn-wrapper" }, Be = { class: "select-count" }, He = { key: 4 }, Pe = /* @__PURE__ */ be({
  name: "GTTable",
  __name: "index",
  props: /* @__PURE__ */ J({
    tableOperators: { type: Array, required: !1, default: () => [] },
    recordOperators: { type: Array, required: !1, default: () => [] },
    fields: { type: Array, required: !0 },
    data: { type: Array, required: !0 },
    keyField: { type: String, required: !1, default: "_id" },
    dicts: { type: Array, required: !1, default: () => [] },
    allowSelect: { type: Boolean, required: !1, default: !1 },
    bordered: { type: Boolean, required: !1, default: !1 },
    loading: { type: Boolean, required: !1, default: !1 },
    total: { type: Number, required: !1, default: 0 },
    pageSize: { type: Number, required: !1 },
    pageCurrent: { type: Number, required: !1 },
    operatorWidth: { type: Number, required: !1 },
    groups: { type: Object, required: !1, default: () => ({}) },
    yOffset: { type: [Number, null], required: !1, default: null }
  }, {
    pageCurrent: { type: Number, default: 1 },
    pageCurrentModifiers: {},
    pageSize: { type: Number, default: 10 },
    pageSizeModifiers: {}
  }),
  emits: /* @__PURE__ */ J(["tableOperatorClick", "recordOperatorClick", "refresh"], ["update:pageCurrent", "update:pageSize"]),
  setup(h, { emit: X }) {
    const v = h, Y = Q(h, "pageCurrent"), Z = Q(h, "pageSize"), F = X, { getDictValue: c, getDictItem: x } = Ne(v), { formatFieldValue: ee } = Ae(x), { tableOperatorsList: te, recordOperatorsList: oe, getVisible: H, getDisabled: _ } = Fe(v), { columns: ae } = qe(v), { selectedRowKeys: w, borderedCom: le, scroll: re, dataSource: ne, selectCount: ie, sort: I } = De(v), se = _e(() => v.allowSelect ? {
      columnWidth: 60,
      selectedRowKeys: w.value,
      onChange: de
    } : null), de = (r) => {
      w.value = r;
    }, pe = (r, f, u) => {
      const { field: A } = u;
      let D = u.order ? u.order.replace("end", "") : "";
      I.value = { field: A, order: D }, R();
    }, ce = (r) => {
      F("tableOperatorClick", {
        key: r,
        data: e(w),
        selectedKeys: e(w)
      });
    }, q = (r, f) => {
      F("recordOperatorClick", { key: r, data: f, record: f });
    }, K = (r, f) => {
      Y.value = r, Z.value = f, R();
    }, R = () => F("refresh", e(I));
    return (r, f) => {
      const u = g("a-button"), A = g("a-alert"), D = g("a-tag"), E = g("a-popconfirm"), T = g("a-divider"), ue = g("a-popover"), ye = g("a-table"), fe = g("a-pagination");
      return o(), i("div", Ve, [
        z("div", $e, [
          z("div", Me, [
            (o(!0), i(m, null, B(e(te), (t, l) => (o(), s(u, {
              key: l,
              type: t.type || "primary",
              disabled: !!t.disabled,
              onClick: (n) => ce(t.key)
            }, {
              icon: a(() => [
                t.icon ? (o(), s(C, {
                  key: 0,
                  icon: t.icon
                }, null, 8, ["icon"])) : k("", !0)
              ]),
              default: a(() => [
                d(" " + p(t.label), 1)
              ]),
              _: 2
            }, 1032, ["type", "disabled", "onClick"]))), 128))
          ]),
          r.allowSelect ? (o(), s(A, {
            key: 0,
            type: "warning"
          }, {
            message: a(() => [
              z("span", null, [
                d("已选择 "),
                z("span", Be, p(e(ie)), 1),
                d(" 项")
              ]),
              y(u, {
                type: "link",
                onClick: f[0] || (f[0] = (t) => w.value = [])
              }, {
                default: a(() => [
                  d("清空")
                ]),
                _: 1
              })
            ]),
            _: 1
          })) : k("", !0)
        ]),
        y(ye, {
          ref: "table",
          size: "middle",
          loading: r.loading,
          bordered: e(le),
          columns: e(ae),
          "data-source": e(ne),
          pagination: !1,
          scroll: e(re),
          rowKey: r.keyField,
          rowSelection: e(se),
          onChange: pe
        }, {
          bodyCell: a(({ column: t, record: l, text: n }) => [
            e(we)(t) ? Se(r.$slots, t.name, {
              key: 0,
              text: l[t.name],
              record: l
            }, () => [
              (o(), i("span", {
                key: t.name
              }, p(n), 1))
            ], !0) : e(Oe)(t) ? (o(), i(m, { key: 1 }, [
              d(p(e(ee)(n, t)), 1)
            ], 64)) : e(ze)(t) ? (o(), i(m, { key: 2 }, [
              e(c)(t, n, "tag") ? (o(), s(D, {
                key: 0,
                color: e(c)(t, n, "tagColor")
              }, {
                default: a(() => [
                  e(c)(t, n, "tagIcon") ? (o(), s(C, {
                    key: 0,
                    icon: e(c)(t, n, "tagIcon")
                  }, null, 8, ["icon"])) : k("", !0),
                  d(" " + p(e(c)(t, n, "label")), 1)
                ]),
                _: 2
              }, 1032, ["color"])) : (o(), i("span", {
                key: 1,
                style: b({ color: e(c)(t, n, "labelColor") })
              }, [
                e(c)(t, n, "icon") ? (o(), s(C, {
                  key: 0,
                  icon: e(c)(t, n, "icon"),
                  style: b({
                    color: e(c)(t, n, "iconColor"),
                    fontSize: e(c)(t, n, "fontSize")
                  })
                }, null, 8, ["icon", "style"])) : k("", !0),
                d(" " + p(e(c)(t, n, "label")), 1)
              ], 4))
            ], 64)) : t.name === e(U).OPERATION_NAME ? (o(!0), i(m, { key: 3 }, B(e(oe), ({
              label: S,
              key: L,
              expression: ge,
              color: V,
              icon: W,
              disabled: $,
              confirm: me,
              children: j
            }) => (o(), i(m, null, [
              j ? (o(), s(ue, {
                placement: "bottom",
                class: "operation-box",
                key: S
              }, {
                content: a(() => [
                  (o(!0), i(m, null, B(j, ({ label: O, key: G, expression: ke, color: P, icon: N, disabled: M, confirm: Ce }) => (o(), i(m, null, [
                    e(H)(ke, l) ? (o(), i("span", {
                      class: "operation-box",
                      style: { display: "block" },
                      key: O
                    }, [
                      Ce && !e(_)(M, l) ? (o(), s(E, {
                        key: 0,
                        placement: "topRight",
                        title: `确定要${O}吗？`,
                        onConfirm: () => q(G, l)
                      }, {
                        default: a(() => [
                          y(u, {
                            type: "link",
                            disabled: e(_)(M, l),
                            style: b({ color: P || "" })
                          }, {
                            icon: a(() => [
                              N ? (o(), s(C, {
                                key: 0,
                                icon: N
                              }, null, 8, ["icon"])) : k("", !0)
                            ]),
                            default: a(() => [
                              d(" " + p(O), 1)
                            ]),
                            _: 2
                          }, 1032, ["disabled", "style"])
                        ]),
                        _: 2
                      }, 1032, ["title", "onConfirm"])) : (o(), s(u, {
                        key: 1,
                        type: "link",
                        disabled: e(_)(M, l),
                        onClick: (Ie) => q(G, l),
                        style: b({ color: P || "" })
                      }, {
                        icon: a(() => [
                          N ? (o(), s(C, {
                            key: 0,
                            icon: N
                          }, null, 8, ["icon"])) : k("", !0)
                        ]),
                        default: a(() => [
                          d(" " + p(O), 1)
                        ]),
                        _: 2
                      }, 1032, ["disabled", "onClick", "style"]))
                    ])) : k("", !0)
                  ], 64))), 256))
                ]),
                default: a(() => [
                  y(T, { type: "vertical" }),
                  z("a", {
                    style: b({ color: V }),
                    class: "genduo-box"
                  }, [
                    d(p(S || "更多") + " ", 1),
                    y(C, { icon: "DownOutlined" })
                  ], 4)
                ]),
                _: 2
              }, 1024)) : (o(), i(m, { key: 1 }, [
                e(H)(ge, l) ? (o(), i("span", {
                  class: "operation-box",
                  key: S
                }, [
                  y(T, { type: "vertical" }),
                  me && !e(_)($, l) ? (o(), s(E, {
                    key: 0,
                    placement: "topRight",
                    title: `确定要${S}吗？`,
                    onConfirm: () => q(L, l)
                  }, {
                    default: a(() => [
                      y(u, {
                        type: "link",
                        disabled: e(_)($, l),
                        style: b({ color: V || "" })
                      }, {
                        icon: a(() => [
                          y(C, { icon: W }, null, 8, ["icon"])
                        ]),
                        default: a(() => [
                          d(" " + p(S), 1)
                        ]),
                        _: 2
                      }, 1032, ["disabled", "style"])
                    ]),
                    _: 2
                  }, 1032, ["title", "onConfirm"])) : (o(), s(u, {
                    key: 1,
                    type: "link",
                    disabled: e(_)($, l),
                    onClick: (O) => q(L, l),
                    style: b({ color: V || "" })
                  }, {
                    icon: a(() => [
                      y(C, { icon: W }, null, 8, ["icon"])
                    ]),
                    default: a(() => [
                      d(" " + p(S), 1)
                    ]),
                    _: 2
                  }, 1032, ["disabled", "onClick", "style"]))
                ])) : k("", !0)
              ], 64))
            ], 64))), 256)) : (o(), i("span", He, p(l[t.name]), 1))
          ]),
          _: 3
        }, 8, ["loading", "bordered", "columns", "data-source", "scroll", "rowKey", "rowSelection"]),
        he(y(fe, {
          current: h.pageCurrent,
          total: r.total,
          "show-total": (t) => `共 ${t} 条记录`,
          pageSize: h.pageSize,
          pageSizeOptions: e(U).pageSizeOptions,
          showSizeChanger: "",
          onChange: K,
          onShowSizeChange: K
        }, null, 8, ["current", "total", "show-total", "pageSize", "pageSizeOptions"]), [
          [ve, r.total != 0]
        ])
      ]);
    };
  }
});
export {
  Pe as default
};
