import l from "./Calculator.ts";
import u from "./Factory.ts";
class c extends l {
  constructor(e, a, t) {
    super(e, a, t);
  }
  /**
   * 用于对子表求和
   * 1. 对子表的单个字段求和
   * ["sum", "sub_form", "field"]
   * 2. 对子表字段进行计算之后再求和
   * ["sum", "sub_form", ["*", "field1", "field2"]]
   */
  calc() {
    const e = this.expression[1], a = this.formData[e];
    if (!a)
      return;
    const t = a.data;
    if (!t)
      return;
    const r = this.expression[2];
    let s = 0;
    return Array.isArray(r) ? s = this.getSumByCalculator(t, r) : s = this.getSumByField(t, r), parseFloat((s / t.length).toFixed(2));
  }
  // 从子表中获取字段值加和
  getSumByField(e, a) {
    if (!a || !e || !Array.isArray(e))
      return;
    const t = e.map((r) => r[a]).filter((r) => !isNaN(r) && r !== null);
    return t.length > 0 ? t.reduce((r, s) => r + s) : 0;
  }
  // 对子表中的单条记录按照公司计算，将计算结果加和
  getSumByCalculator(e, a) {
    if (!e || !Array.isArray(e) || !a || !Array.isArray(a))
      return;
    let t = e.map((r) => {
      const s = u.createCalculator(a, r);
      if (s)
        return s.calc();
    });
    return t = t.filter((r) => !isNaN(r) && r !== null), t.length > 0 ? t.reduce((r, s) => r + s) : 0;
  }
  getFields() {
    if (!(!this.expression || !Array.isArray(this.expression)))
      return [this.expression[1]];
  }
}
export {
  c as default
};
