import { defineComponent as M, computed as p, ref as f, onMounted as O, resolveComponent as h, openBlock as V, createBlock as j, unref as l, withCtx as k, createVNode as G, isRef as H } from "vue";
import L from "../../BaseFields/index.ts";
import { keyBy as S } from "lodash";
const U = /* @__PURE__ */ M({
  name: "CascaderField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(m, { expose: v }) {
    const r = m, { label: _, field: i, required: b, readonly: w, placeholder: y, inputValue: n, hide: C, eventBus: g } = L(r), x = p(() => !r.options.hideClear), q = p(() => r.options.showSearch), s = f([]), c = f({});
    O(() => {
      F();
    });
    const B = () => {
      d(n.value);
    };
    function A(e, a) {
      return a.some((o) => o.label.toLowerCase().indexOf(e.toLowerCase()) > -1);
    }
    function F() {
      const { items: e, type: a } = r.options.dict;
      a === "enum" ? s.value = e == null ? void 0 : e.map((o) => ({
        label: o,
        value: o
      })) : a === "inline" && (s.value = e), c.value = u(s.value);
    }
    function u(e) {
      let a = S(e, "value");
      if (Array.isArray(e) && e.length > 0)
        for (let o = 0; o < e.length; o++) {
          const { children: t } = e[o];
          t && (a = { ...a, ...u(t) });
        }
      return a;
    }
    function d(e) {
      n.value = e;
      let a = [];
      Array.isArray(e) && (a = e.map((o) => {
        var t;
        return ((t = c.value[o]) == null ? void 0 : t.data) || c.value[o];
      })), g.emit("change", { field: i, value: e, data: a });
    }
    return v({ reset: () => {
      d(null);
    }, field: i, setValue: d }), (e, a) => {
      const o = h("a-cascader"), t = h("GTField");
      return V(), j(t, {
        label: l(_),
        field: l(i),
        required: l(b),
        hide: l(C)
      }, {
        default: k(() => [
          G(o, {
            options: l(s),
            value: l(n),
            "onUpdate:value": a[0] || (a[0] = (I) => H(n) ? n.value = I : null),
            placeholder: l(y),
            onChange: B,
            "show-search": l(q) ? { filterHandler: A } : !1,
            "allow-clear": l(x),
            disabled: l(w)
          }, null, 8, ["options", "value", "placeholder", "show-search", "allow-clear", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  U as default
};
