import { defineComponent as R, ref as n, onMounted as S, onUnmounted as h, openBlock as x, createElementBlock as k } from "vue";
import "../../../../../../node_modules/mapbox-gl/dist/mapbox-gl.css.ts";
import s from "../../../../../../node_modules/mapbox-gl/dist/mapbox-gl.ts";
import w from "../../../../../../node_modules/axios/lib/axios.ts";
import { message as _ } from "ant-design-vue";
const A = { id: "lonLatMap" }, C = "pk.eyJ1IjoiZ2lzcGFjZSIsImEiOiJtZ2E3c040In0.eRsxR55yq-3zxET8omrmZA", V = /* @__PURE__ */ R({
  __name: "index",
  emits: ["loading", "change"],
  setup(O, { emit: u }) {
    const e = n(), l = n(), r = n(), i = n(0), d = n(0);
    s.accessToken = C, S(() => {
      v();
    });
    const p = [
      "7312e19f34ffbe026d8bcc9170b09b0e",
      "bb74c3ba588dab987a7dee5d30938ead",
      "2760a4b142a494210d757cc2d8358500",
      "c0032fdcdf378f6ab550aae9e5fb8495",
      "42c374a7d8836a1a7a5a4390d64d4226",
      "d2afb498a1b6923ac8759439202c1041",
      "fd807db71572159675e9617b45cb4108",
      "6a87ad7714e765da8107332559393fd1",
      "b48cc5d82c84b39d2bb171d537ea85c8"
    ], v = () => {
      var t;
      const a = p[Math.floor(Math.random() * p.length)];
      e.value = new s.Map({
        container: "lonLatMap",
        style: {
          version: 8,
          sources: {
            baseMap: {
              type: "raster",
              tiles: [
                `http://t0.tianditu.gov.cn/vec_w/wmts?tk=${a}&SERVICE=WMTS&REQUEST=GetTile&VERSION=1.0.0&STYLE=default&TILEMATRIXSET=w&TILEMATRIX={z}&TILEROW={y}&TILECOL={x}&FORMAT=tiles&LAYER=vec`
              ]
              // tileSize: 256,
              // maxzoom: 16,
            },
            "cia-map": {
              type: "raster",
              tiles: [
                `https://t0.tianditu.gov.cn/cva_w/wmts?tk=${a}&SERVICE=WMTS&REQUEST=GetTile&VERSION=1.0.0&STYLE=default&TILEMATRIXSET=w&TILEMATRIX={z}&TILEROW={y}&TILECOL={x}&FORMAT=tiles&LAYER=cva`
              ]
              // tileSize: 256,
              // maxzoom: 16,
            }
          },
          layers: [
            {
              id: "baseMap",
              type: "raster",
              source: "baseMap"
            },
            {
              id: "cia-map",
              type: "raster",
              source: "cia-map"
            }
          ]
        },
        center: [107, 34],
        zoom: 4.5
      }), (t = e.value) == null || t.on("load", () => {
        e.value.resize(), e.value.addControl(new s.NavigationControl({ showCompass: !1 })), r.value = new s.Popup({
          anchor: "top-left",
          closeButton: !1,
          closeOnClick: !1,
          maxWidth: "300px",
          className: "lonLatPopup"
        }), l.value = new s.Marker(), e.value.on("mousemove", E);
      }), e.value.on("click", T);
    }, T = async (a) => {
      l.value.setLngLat([a.lngLat.lng, a.lngLat.lat]).addTo(e.value), L(a.lngLat.lng, a.lngLat.lat);
    }, E = (a) => {
      i.value = a.lngLat.lng, d.value = a.lngLat.lat, r.value.setLngLat(a.lngLat).setText(`${i.value}, ${d.value}`).addTo(e.value);
    }, c = u, L = async (a, t) => {
      var m;
      try {
        c("loading", !0);
        const o = await w({
          method: "get",
          url: "http://39.104.71.14/api/gis-server/admin/adminQueryService/point/query",
          params: {
            lon: a,
            lat: t
          }
        }), { townName: f, cityName: g, countyName: b, provinceName: y } = o.data.data;
        let I = `${y || ""}${g || ""}${b || ""}${f || ""}`, M = (m = o == null ? void 0 : o.data) == null ? void 0 : m.data;
        c("change", a, t, I, M);
      } catch (o) {
        _.error(o);
      } finally {
        c("loading", !1);
      }
    };
    return h(() => {
      e.value = void 0;
    }), (a, t) => (x(), k("div", A));
  }
});
export {
  V as default
};
