import g from "../../../../../node_modules/dayjs/dayjs.min.ts";
import { customAlphabet as l } from "../../../../../node_modules/nanoid/index.browser.ts";
import c from "../../../../../node_modules/crypto-js/enc-base64.ts";
import y from "../../../../../node_modules/crypto-js/hmac-sha1.ts";
import S from "../../../../../node_modules/crypto-js/enc-utf8.ts";
import x from "../../../../apis/file/index.ts";
import { message as T } from "ant-design-vue";
const D = 5, I = 1024 * 1024 * 1024, N = l("abcdefghijklmnopqrstuvwxyz1234567890", 32);
function h(t) {
  const e = /* @__PURE__ */ new Date();
  e.setMinutes(e.getMinutes() + D);
  const n = JSON.stringify({
    expiration: e.toISOString(),
    conditions: [["content-length-range", 0, I]]
  }), r = c.stringify(S.parse(n)), s = c.stringify(y(r, t));
  return {
    policy: r,
    signature: s
  };
}
function A(t, e = "", n = "") {
  if (!t)
    return "";
  const r = g().format("YYYYMMDD"), s = N();
  return `${n ? `${n}/` : ""}${e}/${r}/${s}.${t}`;
}
function M(t) {
  const e = t.lastIndexOf(".");
  return e === -1 ? "notype" : t.slice(e + 1);
}
async function Y(t, e) {
  const n = await x.getTempToken();
  if (!n) {
    T.error("未获取oss地址配置，请刷新页面！");
    return;
  }
  const r = M(t.url || t.name), { accessKeySecret: s, accessKeyId: i, securityToken: p, endPoint: u, dir: f } = n, a = A(r, e, f), { policy: d, signature: m } = h(s), o = new FormData();
  return o.append("key", a), o.append("name", t.name), o.append("policy", d), o.append("signature", m), o.append("OSSAccessKeyId", i), o.append("success_action_status", 200), o.append("x-oss-security-token", p), o.append("file", t), { endPoint: u, data: o, fileName: a };
}
function z(t, e) {
  return e ? (e = e.split(","), t = t.toLocaleLowerCase(), e.some((n) => t.endsWith(n))) : !0;
}
function C(t, e) {
  if (!e)
    return !1;
  if (t / 1024 > e)
    return !0;
}
export {
  C as exceedSizeLimit,
  Y as getUploadData,
  N as nanoid,
  z as testFormat
};
