import { defineComponent as _, ref as r, onMounted as w, openBlock as R, createElementBlock as b, createVNode as M, unref as s } from "vue";
import q from "../../../../../components/ResourceTable/index.vue.ts";
import x from "../../../../../apis/menu/index.ts";
import c from "../../../../../apis/role/index.ts";
import { message as n } from "ant-design-vue";
const k = { class: "menu-box" }, L = /* @__PURE__ */ _({
  __name: "index",
  props: {
    currentRoleItem: { type: Object, required: !0 }
  },
  setup(d) {
    let u = r(0), o = r(!1);
    const i = r([]), l = r([]), m = d, f = [
      {
        title: "名称",
        dataIndex: "name"
      },
      {
        title: "路径",
        dataIndex: "uri"
      },
      {
        title: "组件",
        dataIndex: "component"
      }
    ], p = async () => {
      o.value = !0;
      try {
        const e = await x.queryMenuTree();
        i.value = e, u.value = e.length;
      } catch ({ msg: e }) {
        n.error(e);
      } finally {
        o.value = !1;
      }
    }, y = async () => {
      const { _id: e } = m.currentRoleItem, t = await c.queryAuthorizeMenus(e);
      l.value = t.map((a) => a._id);
    };
    w(async () => {
      await p(), await y();
    });
    const v = async (e, t) => {
      const { _id: a } = m.currentRoleItem;
      t ? await g(a, e) : await h(a, e);
    }, g = async (e, t) => {
      o.value = !0;
      try {
        await c.authorizeMenu(e, t), n.success("授权成功"), l.value.push(...t);
      } catch ({ msg: a }) {
        n.error(a);
      } finally {
        o.value = !1;
      }
    }, h = async (e, t) => {
      o.value = !0;
      try {
        await c.revokeMenu(e, t), n.success("取消授权成功"), l.value = l.value.filter((a) => !t.includes(a));
      } catch ({ msg: a }) {
        n.error(a);
      } finally {
        o.value = !1;
      }
    };
    return (e, t) => (R(), b("div", k, [
      M(q, {
        columns: f,
        tableData: s(i),
        tableLoading: s(o),
        onRowClick: v,
        total: s(u),
        selectedRowKeysFlag: s(l),
        pagination: !1,
        scrollY: 240
      }, null, 8, ["tableData", "tableLoading", "total", "selectedRowKeysFlag"])
    ]));
  }
});
export {
  L as default
};
