import { defineComponent as F, ref as l, onMounted as z, resolveComponent as C, openBlock as k, createElementBlock as q, createVNode as p, unref as s } from "vue";
import { message as n } from "ant-design-vue";
import { searchFields as x } from "./config.ts";
import D from "../../../../../apis/formDesign/index.ts";
import m from "../../../../../apis/role/index.ts";
import L from "../../../../../components/ResourceTable/index.vue.ts";
const S = { class: "authorization-box" }, H = /* @__PURE__ */ F({
  __name: "ModifyResource",
  props: {
    currentRoleItem: { type: Object, required: !0 },
    resourcesIds: { type: Array, required: !0 }
  },
  setup(g) {
    const v = [
      {
        title: "表单标题",
        dataIndex: "table_title"
      },
      {
        title: "表单名称",
        dataIndex: "table_name"
      },
      {
        title: "表单描述",
        dataIndex: "description"
      }
    ], i = g;
    let c = l({
      page: 1,
      size: 10
    });
    const d = l([]);
    let o = l(!1), f = l(0), r = l([...i.resourcesIds]);
    const y = async (e, a) => {
      c.value.page = e, c.value.size = a, await u();
      const { _id: t } = i.currentRoleItem, w = await m.getRoleFormList(t);
      r.value = w.map((I) => I._id);
    }, u = async () => {
      o.value = !0;
      try {
        const e = await D.searchFormDesign(c.value);
        d.value = e.list, f.value = e.total;
      } catch ({ msg: e }) {
        n.error(e);
      } finally {
        o.value = !1;
      }
    }, h = async (e) => {
      let a = {
        page: 1,
        size: 10
      };
      e.length != 0 && e.forEach((t) => {
        a[t.name] = t.value;
      }), c.value = a, await u();
    }, R = async (e, a) => {
      const { _id: t } = i.currentRoleItem;
      a ? await b(t, e) : await _(t, e);
    }, b = async (e, a) => {
      o.value = !0;
      try {
        await m.bindForm(e, a), n.success("授权成功"), r.value.push(...a);
      } catch ({ msg: t }) {
        n.error(t);
      } finally {
        o.value = !1;
      }
    }, _ = async (e, a) => {
      o.value = !0;
      try {
        await m.unbindForm(e, a), n.success("取消授权成功"), r.value = r.value.filter((t) => !a.includes(t));
      } catch ({ msg: t }) {
        n.error(t);
      } finally {
        o.value = !1;
      }
    };
    return z(async () => {
      await u();
    }), (e, a) => {
      const t = C("GTSearch");
      return k(), q("div", S, [
        p(t, {
          fields: s(x),
          onSearch: h
        }, null, 8, ["fields"]),
        p(L, {
          currentRoleItem: e.currentRoleItem,
          tableData: s(d),
          tableLoading: s(o),
          columns: v,
          onRowClick: R,
          selectedRowKeysFlag: s(r),
          total: s(f),
          onPageSizeChange: y,
          myPagination: "authorizationForm"
        }, null, 8, ["currentRoleItem", "tableData", "tableLoading", "selectedRowKeysFlag", "total"])
      ]);
    };
  }
});
export {
  H as default
};
