import { defineComponent as C, ref as u, computed as k, onMounted as z, resolveComponent as L, openBlock as F, createElementBlock as B, createElementVNode as v, createTextVNode as E, toDisplayString as j, unref as s, createVNode as y } from "vue";
import G from "../../../../../apis/dataRule/index.ts";
import H from "../../../../../components/ResourceTable/index.vue.ts";
import { message as n } from "ant-design-vue";
import { ruleSearchFields as O } from "./config.ts";
import m from "../../../../../apis/role/index.ts";
const P = { class: "rule-box" }, V = { class: "form-name" }, W = /* @__PURE__ */ C({
  __name: "Rule",
  props: {
    currentRoleItem: { type: Object, required: !0 },
    ruleResourceId: { type: String, required: !0 },
    ruleResourceTableName: { type: String, required: !0 }
  },
  setup(_) {
    const r = _, b = r.ruleResourceTableName, f = r.ruleResourceId, h = [
      {
        title: "规则名称",
        dataIndex: "name"
      },
      {
        title: "规则表",
        dataIndex: "rule_table"
      },
      {
        title: "规则字段",
        dataIndex: "rule_column"
      },
      {
        title: "条件规则",
        dataIndex: "rule_conditions"
      },
      {
        title: "规则值",
        dataIndex: "rule_value"
      }
    ], c = u([]);
    let l = u(!1), p = u(0), i = u({
      page: 1,
      size: 10
    }), d = u("");
    const o = u([]), I = async (e, a) => {
      i.value.page = e, i.value.size = a, await g();
      const { _id: t } = r.currentRoleItem, R = await m.getDataRules(t, f);
      o.value = R.list.map((N) => N._id);
    }, g = async () => {
      l.value = !0, c.value = [], Object.assign(i.value, { rule_table: r.ruleResourceId });
      try {
        const e = await G.getRules(i.value);
        p.value = e.total, c.value = e.list;
      } catch (e) {
        n.error(e.msg);
      } finally {
        l.value = !1;
      }
    }, D = async (e, a) => {
      try {
        const t = await m.getDataRules(e, a);
        o.value = t.list.map((R) => R._id);
      } catch ({ msg: t }) {
        n.error(t);
      }
    }, w = (e) => {
      e.length != 0 ? e.forEach((a) => {
        d.value = a.value;
      }) : d.value = "";
    }, S = k(() => d.value ? c.value.filter((e) => e.name.includes(d.value)) : c.value), T = async (e, a) => {
      const { _id: t } = r.currentRoleItem;
      a ? await x(t, e) : await q(t, e);
    }, x = async (e, a) => {
      l.value = !0;
      try {
        await m.bindDataRule(e, a), n.success("授权成功"), o.value.push(...a);
      } catch ({ msg: t }) {
        n.error(t);
      } finally {
        l.value = !1;
      }
    }, q = async (e, a) => {
      l.value = !0;
      try {
        await m.unbindDataRule(e, a), n.success("取消授权成功"), o.value = o.value.filter((t) => !a.includes(t));
      } catch ({ msg: t }) {
        n.error(t);
      } finally {
        l.value = !1;
      }
    };
    return z(() => {
      const { _id: e } = r.currentRoleItem;
      g(), D(e, f);
    }), (e, a) => {
      const t = L("GTSearch");
      return F(), B("div", P, [
        v("div", V, [
          v("strong", null, [
            E(" 表单名称："),
            v("span", null, j(s(b)), 1)
          ])
        ]),
        y(t, {
          fields: s(O),
          onSearch: w
        }, null, 8, ["fields"]),
        y(H, {
          columns: h,
          currentRoleItem: e.currentRoleItem,
          tableData: s(S),
          tableLoading: s(l),
          onRowClick: T,
          total: s(p),
          selectedRowKeysFlag: s(o),
          onPageSizeChange: I,
          myPagination: "rule"
        }, null, 8, ["currentRoleItem", "tableData", "tableLoading", "total", "selectedRowKeysFlag"])
      ]);
    };
  }
});
export {
  W as default
};
