import { defineComponent as F, ref as a, onMounted as H, resolveComponent as _, openBlock as b, createElementBlock as B, createBlock as G, Suspense as S, withCtx as y, createVNode as u, unref as r, isRef as L } from "vue";
import { dicts as k, formOptions as h, fields as E, searchItems as I, tableOperators as N, recordOperators as q, getRoles as A, formDicts as P } from "./config.ts";
import { keyBy as V, cloneDeep as j } from "lodash";
import z from "./components/Form/index.vue.ts";
import i from "../../apis/user/index.ts";
import { message as n } from "ant-design-vue";
const J = { class: "form-design-max" }, K = "tb_user_info_map", te = /* @__PURE__ */ F({
  name: "UserManage",
  __name: "index",
  setup(Q) {
    const l = a(), v = {
      tableFields: E,
      searchItems: I,
      tableOperators: N,
      recordOperators: q,
      dicts: k
    };
    async function g() {
      l.value.getList(), o.value = !1;
    }
    const o = a(!1);
    let m = a({});
    const c = a(""), f = a();
    function D({ key: t, data: e }) {
      switch (t) {
        case "_add":
          c.value = "添加", w();
          break;
        case "_reset":
          O(e);
          break;
        case "_edit":
          c.value = "编辑", T(e);
          break;
        case "_delete":
          M(e.user_id);
          break;
        case "_stop":
          p(e.enabled, e.user_id);
          break;
        case "_start":
          p(e.enabled, e.user_id);
          break;
      }
    }
    function w() {
      o.value = !0;
    }
    async function O(t) {
      try {
        t.userIds = [t.user_id];
        let e = await i.resetUserPasswords(t);
        n.success(e);
      } catch ({ msg: e }) {
        n.error("重置密码失败");
      }
    }
    function T(t) {
      m.value = t, o.value = !0;
    }
    async function M(t) {
      try {
        (await i.deleteUser(t))._id && (n.success("删除成功"), l.value.getList());
      } catch {
        n.error("删除失败");
      }
    }
    async function p(t, e) {
      try {
        let s;
        t ? s = await i.suspendUser(e) : s = await i.resumeUser(e), n.success(s), l.value.getList();
      } catch {
        n.error("停用失败");
      }
    }
    async function x() {
      await f.value.onSubmit();
    }
    const d = a();
    async function C() {
      let t = await A();
      d.value = V(t, "label");
      let e = j(P), s = {
        name: "role",
        type: "inline",
        items: t
      };
      e.push(s), h.formDef.dicts = e;
    }
    return H(async () => {
      await C();
    }), (t, e) => {
      const s = _("GTSearchTable"), R = _("a-modal");
      return b(), B("div", J, [
        (b(), G(S, null, {
          default: y(() => [
            u(s, {
              "form-name": K,
              onOperate: D,
              tableOptions: v,
              ref_key: "search_table",
              ref: l,
              customDicts: r(k)
            }, null, 8, ["customDicts"])
          ]),
          _: 1
        })),
        u(R, {
          class: "form-design-model",
          getContainer: ".form-design-max",
          destroyOnClose: "",
          open: r(o),
          "onUpdate:open": e[0] || (e[0] = (U) => L(o) ? o.value = U : null),
          title: r(c),
          onOk: x
        }, {
          default: y(() => [
            u(z, {
              options: r(h),
              onRefreshTable: g,
              formData: r(m),
              type: r(c),
              ref_key: "GTForm",
              ref: f,
              roleMap: r(d)
            }, null, 8, ["options", "formData", "type", "roleMap"])
          ]),
          _: 1
        }, 8, ["open", "title"])
      ]);
    };
  }
});
export {
  te as default
};
