import { defineComponent as _, ref as d, onMounted as g, resolveComponent as h, openBlock as u, createElementBlock as k, createVNode as l, createElementVNode as m, createBlock as y, unref as b } from "vue";
import { getMenuData as v, addRoutes as I, getFirstVisibleMenu as R } from "../utils/useRoute.ts";
import B from "../apis/login/index.ts";
import w from "../layout/NavBar.vue.ts";
import x from "../layout/MenuBar.vue.ts";
import { useInfoStore as M } from "../stores/modules/info.ts";
import V from "../apis/formData/index.ts";
import { useRouter as S, useRoute as C } from "../../node_modules/vue-router/dist/vue-router.ts";
const D = { class: "home-max" }, N = { class: "content-max" }, O = { class: "content-box" }, K = /* @__PURE__ */ _({
  __name: "Workspace",
  setup(j) {
    const a = S(), n = C(), { setValue: i } = M(), s = d();
    g(async () => {
      await f();
      const o = await v();
      if (o) {
        const { menuList: e, routes: t } = o;
        i("menuList", e), I(t, a), p(e);
      }
    });
    const f = async () => {
      const o = localStorage.getItem("user_id");
      if (!o) {
        a.push("/login");
        return;
      }
      let e = await B.getUserInformation();
      if (o)
        try {
          const { list: t } = await V.searchFormData("tb_user_info_map", {
            filter: ["=", "user_id", o]
          });
          t.length > 0 && (e = Object.assign({}, t[0], e));
        } catch (t) {
          console.log("用户信息映射表-error :>> ", t);
        }
      i("userInfo", e), localStorage.setItem("userInfo", JSON.stringify(e));
    }, p = (o) => {
      if (n.path === "/") {
        const e = R(o);
        s.value.menuClick(e);
      } else {
        let { path: e, query: t } = n, r = e;
        if (Object.keys(t).length != 0) {
          r += "?";
          for (const c in t)
            r += `${c}=${t[c]}&`;
          r = r.slice(0, r.length - 1);
        }
        s.value.menuClick({ key: r });
      }
    };
    return (o, e) => {
      const t = h("RouterView");
      return u(), k("div", D, [
        l(w, { class: "navbar-box" }),
        m("div", N, [
          l(x, {
            ref_key: "MenuBarRef",
            ref: s
          }, null, 512),
          m("div", O, [
            (u(), y(t, {
              key: b(n).fullPath
            }))
          ])
        ])
      ]);
    };
  }
});
export {
  K as default
};
