import { defineComponent as Q, ref as Y, computed as V, reactive as Z, readonly as ee, provide as x, unref as a, watch as te, nextTick as ae, resolveComponent as B, openBlock as d, createElementBlock as _, createVNode as s, withCtx as v, createElementVNode as b, Fragment as re, renderList as le, withDirectives as O, createBlock as oe, resolveDynamicComponent as ne, vShow as R, createTextVNode as q, toDisplayString as se, createCommentVNode as H } from "vue";
import { uniqueId as ce, cloneDeep as de, mapKeys as ie } from "lodash";
import { SEARCH_STATUS as E } from "./types.ts";
import { getSearchValues as ue } from "./hooks/utils.ts";
import fe from "mitt";
import me from "./hooks/useFields.ts";
import w from "../SvgIcon/index.vue.ts";
const pe = ["id"], he = { class: "search-btn-box" }, Fe = /* @__PURE__ */ Q({
  name: "GTSearch",
  __name: "index",
  props: {
    defaultFields: { type: Object, required: !1, default: () => ({}) },
    fields: { type: Array, required: !0, default: () => [] },
    dicts: { type: Array, required: !1, default: () => [] },
    showNum: { type: Number, required: !1, default: 2 },
    listWidth: { type: Number, required: !1, default: 300 },
    wrapperSpan: { type: Number, required: !1, default: 16 },
    labelSpan: { type: Number, required: !1, default: 8 }
  },
  emits: ["search", "add-height", "change"],
  setup(I, { expose: A, emit: T }) {
    const i = T, r = I, {
      searchFields: u,
      showSearchFields: g,
      DateRangeMap: M,
      dateRangeFields: S,
      searchMap: U,
      isShow: o,
      allHide: W
    } = me(r), F = ce("search_"), K = Y(), D = [], X = (e) => {
      e && D.push(e);
    }, j = { span: r.labelSpan }, G = { span: r.wrapperSpan }, L = V(
      () => o.value ? E.BOX_BACKUP : E.BOX_SHOW
    ), C = r.defaultFields, f = Z(de(C)), m = V(() => ee(f)), P = {
      "grid-template-columns": `repeat(auto-fill, ${r.listWidth}px)`
    }, k = fe();
    x("eventBus", k), x("formRecordData", C), k.on("change", $);
    function p() {
      const e = ue(
        a(m),
        a(M),
        a(U)
      );
      i("search", e);
    }
    function $({ field: e, value: t }) {
      f[e] = t, i("change", { formData: a(m), field: e, value: t });
    }
    function z() {
      o.value = !o.value, u.value.forEach((e) => {
        if (o.value)
          e.show = !0;
        else {
          let t = g.value.indexOf(e.options.field);
          t >= 0 ? e.show = t < r.showNum : e.show = !1;
        }
      });
    }
    function N() {
      const e = ie(D, (t) => t.field);
      u.value.forEach(({ options: t }) => {
        const n = t == null ? void 0 : t.default, l = t == null ? void 0 : t.field;
        if (["", void 0, null].includes(n))
          e[l].reset();
        else if (S[l]) {
          const { startField: h, endField: c } = S[l], y = r.defaultFields[h], J = r.defaultFields[c];
          e[l].setValue(y, J);
        } else
          f[l] !== n && e[l].setValue(n);
      }), p();
    }
    return te(
      () => o.value,
      () => {
        ae(() => {
          var t;
          const e = (t = document.getElementById(F)) == null ? void 0 : t.offsetHeight;
          e && i("add-height", e - 50);
        });
      }
    ), A({ submitHandler: p, reset: N }), (e, t) => {
      const n = B("a-button"), l = B("a-form");
      return e.fields.length > 0 ? (d(), _("div", {
        key: 0,
        id: a(F),
        class: "search-box"
      }, [
        s(l, {
          ref_key: "form",
          ref: K,
          "label-col": j,
          "wrapper-col": G
        }, {
          default: v(() => [
            b("div", {
              class: "body-wrapper",
              style: P
            }, [
              (d(!0), _(re, null, le(a(u), ({ type: h, options: c, show: y }) => O((d(), oe(ne(h), {
                key: c.field,
                options: c,
                formData: a(m),
                ref_for: !0,
                ref: X
              }, null, 8, ["options", "formData"])), [
                [R, y && !c.hide]
              ])), 128)),
              O(b("div", he, [
                s(n, {
                  type: "primary",
                  onClick: p
                }, {
                  default: v(() => [
                    s(w, { icon: "SearchOutlined" }),
                    q(" 查找 ")
                  ]),
                  _: 1
                }),
                s(n, {
                  class: "redo-btn",
                  type: "primary",
                  onClick: N
                }, {
                  default: v(() => [
                    s(w, { icon: "RedoOutlined" }),
                    q(" 重置 ")
                  ]),
                  _: 1
                }),
                a(g).length > e.showNum ? (d(), _("a", {
                  key: 0,
                  class: "button-control",
                  onClick: z
                }, [
                  b("span", null, se(a(L)), 1),
                  s(w, {
                    icon: a(o) ? "UpOutlined" : "DownOutlined"
                  }, null, 8, ["icon"])
                ])) : H("", !0)
              ], 512), [
                [R, !a(W)]
              ])
            ])
          ]),
          _: 1
        }, 512)
      ], 8, pe)) : H("", !0);
    };
  }
});
export {
  Fe as default
};
