import { defineComponent as C, ref as c, computed as p, resolveComponent as d, openBlock as g, createElementBlock as S, createVNode as q, unref as n, createBlock as h, isRef as m, createCommentVNode as k } from "vue";
const z = { class: "table-box" }, R = /* @__PURE__ */ C({
  __name: "index",
  props: {
    tableData: { type: Array, required: !0 },
    columns: { type: Array, required: !0 },
    selectedRowKeysFlag: { type: Array, required: !0 },
    tableLoading: { type: Boolean, required: !1 },
    total: { type: Number, required: !1 },
    rowKey: { type: String, required: !1, default: "_id" },
    scrollY: { type: [Number, String], required: !1, default: 400 },
    myPagination: { type: String, required: !1 },
    pagination: { type: Boolean, required: !1, default: !1 }
  },
  emits: ["rowClick", "pageSizeChange"],
  setup(y, { emit: w }) {
    let a = c(1), r = c(10);
    const l = y, f = p(() => {
      const e = { scrollToFirstRowOnChange: !0 };
      return l.scrollY && (e.y = `calc(100vh - ${l.scrollY}px)`), e;
    }), i = w, K = p(() => ({
      columnWidth: 60,
      // selectedRowKeys为被选择的table数据表单的id
      selectedRowKeys: l.selectedRowKeysFlag,
      //当表单被选中时触发，从而去授权、或者取消授权
      onSelect(e, o) {
        i("rowClick", [e[l.rowKey]], o);
      },
      onSelectAll(e, o, s) {
        const u = s.map((t) => t[l.rowKey]);
        i("rowClick", u, e);
      }
    })), b = (e, o) => {
      a.value = e, r.value = o, i("pageSizeChange", e, o);
    };
    return (e, o) => {
      const s = d("a-table"), u = d("a-pagination");
      return g(), S("div", z, [
        q(s, {
          columns: e.columns,
          "data-source": e.tableData,
          loading: e.tableLoading,
          rowKey: e.rowKey,
          scroll: n(f),
          "row-selection": n(K),
          pagination: e.pagination
        }, null, 8, ["columns", "data-source", "loading", "rowKey", "scroll", "row-selection", "pagination"]),
        e.myPagination == "authorizationForm" || e.myPagination == "rule" ? (g(), h(u, {
          key: 0,
          current: n(a),
          "onUpdate:current": o[0] || (o[0] = (t) => m(a) ? a.value = t : a = t),
          "page-size": n(r),
          "onUpdate:pageSize": o[1] || (o[1] = (t) => m(r) ? r.value = t : r = t),
          total: e.total,
          rowKey: e.rowKey,
          "show-total": (t) => `共${t}条`,
          onChange: b
        }, null, 8, ["current", "page-size", "total", "rowKey", "show-total"])) : k("", !0)
      ]);
    };
  }
});
export {
  R as default
};
