import { defineComponent as L, reactive as S, ref as V, computed as j, readonly as q, provide as p, onUnmounted as E, resolveComponent as G, openBlock as m, createBlock as f, mergeProps as M, unref as n, withCtx as N, createElementBlock as d, Fragment as v, renderList as O, resolveDynamicComponent as P, createCommentVNode as T, toRaw as U } from "vue";
import z from "mitt";
import { cloneDeep as y } from "lodash";
import A from "./hooks/useLayout.ts";
import H from "./hooks/useRules.ts";
const Y = /* @__PURE__ */ L({
  name: "GTForm",
  __name: "index",
  props: {
    options: { type: Object, required: !0 }
  },
  emits: ["change"],
  setup(_, { expose: b, emit: g }) {
    const c = _, { layout: D, itemLayout: h, visibleMap: C } = A(c.options), x = g, u = c.options.formRecordData || {}, i = S(y(u)), l = V(), r = j(() => q(i)), { rules: F, validateForm: k } = H(c.options, r), B = ({ field: o, value: e }) => {
      var t;
      i[o] = e, x("change", { formData: r.value, field: o, value: e }), e && ((t = l.value) == null || t.validateFields([o]));
    }, R = ({ field: o, state: e }) => {
      C.value[o] = e;
    };
    let a = z();
    return p("eventBus", a), p("formRecordData", u), a.on("change", B), a.on("visibleChange", R), b({ submit: async () => {
      var o;
      try {
        const e = await ((o = l.value) == null ? void 0 : o.validate()), t = k();
        if (e && t)
          return { state: !0, data: y(U(r.value)) };
      } catch (e) {
        console.log("error :>> ", e);
      }
      return { state: !1 };
    }, getFormData: r }), E(() => {
      a = null;
    }), (o, e) => {
      const t = G("a-form");
      return m(), f(t, M({
        class: "form-max",
        ref_key: "form",
        ref: l,
        model: n(i),
        name: "basic"
      }, n(h), {
        rules: n(F),
        autocomplete: "off"
      }), {
        default: N(() => [
          (m(!0), d(v, null, O(n(D), (s, w) => (m(), d(v, null, [
            !s.options || s.options.visible !== !1 ? (m(), f(P(s.type), {
              key: w,
              options: s.options,
              formData: n(r)
            }, null, 8, ["options", "formData"])) : T("", !0)
          ], 64))), 256))
        ]),
        _: 1
      }, 16, ["model", "rules"]);
    };
  }
});
export {
  Y as default
};
