import { defineComponent as k, computed as u, onMounted as B, onUnmounted as j, resolveComponent as h, openBlock as D, createBlock as R, unref as n, withCtx as G, createVNode as U, isRef as z } from "vue";
import E from "../../BaseFields/index.ts";
import a from "../../../../../node_modules/dayjs/dayjs.min.ts";
import "../../../../../node_modules/dayjs/locale/zh-cn.ts";
const A = /* @__PURE__ */ k({
  name: "DateRangeField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(v, { expose: F }) {
    a.locale("zh-cn");
    const o = v, { label: _, field: b, required: w, readonly: g, inputValue: t, hide: y, eventBus: s, formRecordData: c } = E(o), C = u(() => !o.options.hideClear), d = o.options.startField.field, f = o.options.endField.field, p = u(() => o.options.showTime), O = u(() => {
      const { startField: l, endField: e } = o.options;
      return l.field && e.field ? [l.label, e.label] : ["开始日期", "结束日期"];
    });
    B(() => {
      const l = o.options.default || [null, null];
      let e = c[d] || l[0], r = c[f] || l[1];
      e && r && (e = a(e), r = a(r), i(e, r), t.value = [e, r]);
    });
    const V = () => {
      if (t.value) {
        const l = m(t.value[0], "start"), e = m(t.value[1], "end");
        i(l, e);
      } else
        i(null, null);
    };
    function i(l, e) {
      l && e && (l = a(l).valueOf(), e = a(e).valueOf()), s.emit("change", { field: d, value: l }), s.emit("change", { field: f, value: e });
    }
    function T() {
      i(null, null), t.value = null;
    }
    function m(l, e) {
      if (p.value)
        return l;
      switch (e) {
        case "start":
          return a(l).startOf("day");
        case "end":
          return a(l).endOf("day");
        default:
          return a(l).startOf("day");
      }
    }
    return j(() => {
      i(null, null), t.value = null;
    }), F({ setValue: i, field: b, reset: T }), (l, e) => {
      const r = h("a-range-picker"), q = h("GTField");
      return D(), R(q, {
        label: n(_),
        field: n(d),
        required: n(w),
        hide: n(y)
      }, {
        default: G(() => [
          U(r, {
            style: { width: "100%" },
            value: n(t),
            "onUpdate:value": e[0] || (e[0] = (x) => z(t) ? t.value = x : null),
            showTime: n(p),
            allowClear: n(C),
            placeholder: n(O),
            onChange: V,
            disabled: n(g)
          }, null, 8, ["value", "showTime", "allowClear", "placeholder", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  A as default
};
