import { defineComponent as w, computed as $, ref as y, onMounted as A, resolveComponent as h, openBlock as D, createBlock as N, unref as i, withCtx as p, createVNode as g, normalizeClass as P, createTextVNode as q, createElementBlock as R, toDisplayString as V, createCommentVNode as W } from "vue";
import H from "../../BaseFields/index.ts";
import I from "./images/file_thumb_word.png.ts";
import G from "./images/file_thumb_excel.png.ts";
import M from "./images/file_thumb_pdf.png.ts";
import X from "./images/file_thumb_default.png.ts";
import { cloneDeep as K } from "lodash";
import { message as _ } from "ant-design-vue";
import J from "../../../SvgIcon/index.vue.ts";
const Q = {
  key: 0,
  class: "accept-desc"
}, se = /* @__PURE__ */ w({
  name: "FileField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(U) {
    const m = "/api/misengine/attachment/download", a = {
      WORD: I,
      EXCEL: G,
      PDF: M,
      DEFAULT: X
    }, s = U, { label: v, field: l, required: F, readonly: b, hide: E, eventBus: C, formRecordData: L } = H(s), u = s.options.max || 1, f = $(() => {
      const { sizeLimit: e } = s.options;
      return !isNaN(e) && e ? e : 0;
    }), c = $(() => {
      const { suffixes: e } = s.options;
      return e ? e.join(",") : "";
    }), O = "/api/misengine/attachment/upload", T = {
      Authorization: `Bearer ${localStorage.getItem("access_token")}`
    }, o = y([]), d = (e) => {
      let r = e || [];
      r = K(r);
      let t = null;
      r.length !== 0 && (t = [], r.forEach((n) => {
        n.url = `${m}/${n.uid}`, n.thumbUrl = x(n), t.push({
          name: n.name,
          uid: n.uid
        });
      })), o.value = r, C.emit("change", { field: l, value: t });
    };
    function j(e) {
      switch (o.value = e.fileList, e.file.status) {
        case "uploading":
          break;
        case "done": {
          const { code: t } = e.file.response;
          if (t === 2e3) {
            e.file.uid = e.file.response.data[0], e.file.url = `${m}/${e.file.uid}`, e.file.thumbUrl = x(e.file);
            const n = o.value.length !== 0 ? o.value.length - 1 : 0;
            o.value[n] = e.file;
          } else
            o.value.pop(), this.$message.error("文件上传失败，请重试");
          d(o.value);
          break;
        }
        case "error":
          o.value.pop(), d(o.value), this.$message.error("文件上传失败，请重试");
          break;
        case "removed":
          d(o.value);
          break;
      }
    }
    function k(e) {
      if (!e || !e.name)
        return Promise.reject();
      if (B(e.size))
        return _.error(`文件大小不能超过${f.value}KB`), Promise.reject();
      if (!z(e.name))
        return _.warning(`只能上传${c.value}的文件`), Promise.reject();
      if (!u)
        return !0;
      if (o.value.length >= u)
        return _.error(`您最多只能上传${u}个${v.value}，请删除后再继续上传`), Promise.reject();
    }
    function z(e) {
      const { suffixes: r } = s.options;
      return r ? (e = e.toLocaleLowerCase(), r.some((t) => e.endsWith(t))) : !0;
    }
    function B(e) {
      if (!f.value)
        return !1;
      if (e / 1024 > f.value)
        return !0;
    }
    function x({ uid: e, name: r }) {
      if (!e || !r)
        return a.DEFAULT;
      const t = r.split(".").pop().toLowerCase();
      return t ? ["doc", "docx"].indexOf(t) >= 0 ? a.WORD : ["xls", "xlsx"].indexOf(t) >= 0 ? a.EXCEL : t === "pdf" ? a.PDF : ["png", "jpeg", "jpg"].indexOf(t) >= 0 ? `${m}/${e}` : a.DEFAULT : a.DEFAULT;
    }
    return A(() => {
      L[l] && d(L[l]);
    }), (e, r) => {
      const t = h("a-button"), n = h("a-upload"), S = h("GTField");
      return D(), N(S, {
        label: i(v),
        field: i(l),
        required: i(F),
        hide: i(E)
      }, {
        default: p(() => [
          g(n, {
            class: P({ "hide-button": i(o).length >= i(u) }),
            name: "files",
            action: O,
            headers: T,
            onChange: j,
            accept: i(c),
            fileList: i(o),
            beforeUpload: k,
            disabled: i(b),
            listType: "picture"
          }, {
            default: p(() => [
              g(t, { disabled: i(b) }, {
                icon: p(() => [
                  g(J, { icon: "UploadOutlined" })
                ]),
                default: p(() => [
                  q(" 上传文件 ")
                ]),
                _: 1
              }, 8, ["disabled"]),
              i(c) ? (D(), R("span", Q, "支持的格式：" + V(i(c)), 1)) : W("", !0)
            ]),
            _: 1
          }, 8, ["class", "accept", "fileList", "disabled"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  se as default
};
