import { defineComponent as z, ref as c, onMounted as M, resolveComponent as b, openBlock as _, createBlock as R, unref as n, withCtx as N, createVNode as r, isRef as U, createElementBlock as x, Fragment as A, renderList as H, createTextVNode as J, toDisplayString as K, normalizeClass as B, pushScopeId as P, popScopeId as Q, createElementVNode as S } from "vue";
import W from "../../BaseFields/index.ts";
import y from "./InputNumber.vue.ts";
import { isNumber as X } from "lodash";
const T = (s) => (P("data-v-efe59f4c"), s = s(), Q(), s), Y = /* @__PURE__ */ T(() => /* @__PURE__ */ S("span", null, "°", -1)), Z = /* @__PURE__ */ T(() => /* @__PURE__ */ S("span", null, "′", -1)), $ = /* @__PURE__ */ T(() => /* @__PURE__ */ S("span", null, "″", -1)), te = /* @__PURE__ */ z({
  name: "LonLatInputField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(s) {
    const C = [
      { label: "度", value: "decimal" },
      { label: "度分秒", value: "degree" }
    ], h = s, { label: D, field: F, required: L, readonly: d, placeholder: w, inputValue: m, hide: j, eventBus: q } = W(h), E = h.options.precision || 6, f = c(h.options.selectType || "degree"), V = c(), u = c(), i = c(), p = c(), k = (e) => {
      if (["", void 0, null, 0].includes(e))
        V.value = null, u.value = null, i.value = null, p.value = null, m.value = null, q.emit("change", { field: F, value: null });
      else {
        X(e) || (e = parseFloat(e)), e = parseFloat(e.toFixed(E));
        const { d: o, f: a, m: t } = O(e);
        V.value = e, u.value = o, i.value = a, p.value = t, m.value = e, q.emit("change", { field: F, value: e });
      }
    };
    M(() => {
      m.value && k(m.value);
    });
    function I(e, o) {
      switch (e = isNaN(e) || e === "" ? 0 : Number(e), o) {
        case "d":
          u.value = e;
          break;
        case "f":
          i.value = e;
          break;
        case "m":
          p.value = e;
          break;
      }
      G();
    }
    function G() {
      let e = u.value || 0, o = i.value || 0, a = p.value || 0;
      o = o + a / 60;
      let t = o / 60 + e;
      k(t);
    }
    function O(e) {
      if (!e)
        return {};
      e = e.toString();
      const o = e.split("."), a = o[0];
      let t = "0." + o[1];
      t = String(t * 60);
      const v = t.split("."), g = v[0];
      t = "0." + v[1];
      const l = t * 60;
      return {
        d: isNaN(a) ? 0 : parseFloat(a),
        f: isNaN(g) ? 0 : parseFloat(g),
        m: isNaN(l) ? 0 : parseFloat(l.toFixed(2))
      };
    }
    return (e, o) => {
      const a = b("a-select-option"), t = b("a-select"), v = b("a-input-group"), g = b("GTField");
      return _(), R(g, {
        label: n(D),
        field: n(F),
        required: n(L),
        hide: n(j)
      }, {
        default: N(() => [
          r(v, {
            compact: "",
            class: "group-box"
          }, {
            default: N(() => [
              r(t, {
                value: n(f),
                "onUpdate:value": o[0] || (o[0] = (l) => U(f) ? f.value = l : null),
                class: "group-type-box"
              }, {
                default: N(() => [
                  (_(), x(A, null, H(C, (l) => r(a, {
                    value: l.value,
                    key: l.value
                  }, {
                    default: N(() => [
                      J(K(l.label), 1)
                    ]),
                    _: 2
                  }, 1032, ["value"])), 64))
                ]),
                _: 1
              }, 8, ["value"]),
              n(f) === "decimal" ? (_(), x("div", {
                key: "decimal",
                class: B(["group-concent group-concent-decimal", { "group-concent-disabled": e.options.readonly }])
              }, [
                r(y, {
                  value: n(V),
                  onInput: k,
                  options: {
                    readonly: n(d),
                    placeholder: n(w),
                    precision: 6
                  }
                }, null, 8, ["value", "options"])
              ], 2)) : (_(), x("div", {
                key: "degree",
                class: B(["group-concent group-concent-degree", { "group-concent-disabled": e.options.readonly }])
              }, [
                r(y, {
                  value: n(u),
                  onInput: o[1] || (o[1] = (l) => I(l, "d")),
                  options: {
                    readonly: n(d),
                    placeholder: "度",
                    precision: 0
                  }
                }, null, 8, ["value", "options"]),
                Y,
                r(y, {
                  value: n(i),
                  onInput: o[2] || (o[2] = (l) => I(l, "f")),
                  options: {
                    readonly: n(d),
                    placeholder: "分",
                    precision: 0
                  }
                }, null, 8, ["value", "options"]),
                Z,
                r(y, {
                  value: n(p),
                  onInput: o[3] || (o[3] = (l) => I(l, "m")),
                  options: {
                    readonly: n(d),
                    placeholder: "秒",
                    precision: 2
                  }
                }, null, 8, ["value", "options"]),
                $
              ], 2))
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  te as default
};
