import { defineComponent as R, computed as y, ref as v, onMounted as S, resolveComponent as _, openBlock as L, createBlock as U, unref as o, withCtx as h, createVNode as g, createElementBlock as E, createCommentVNode as G, createElementVNode as B } from "vue";
import H from "../../BaseFields/index.ts";
import { cloneDeep as K, isString as M } from "lodash";
import A from "../../../../../node_modules/axios/lib/axios.ts";
import { nanoid as q, getUploadData as J, testFormat as Q, exceedSizeLimit as W } from "./utils.ts";
import { message as s } from "ant-design-vue";
import X from "../../../SvgIcon/index.vue.ts";
const Y = { key: 0 }, Z = /* @__PURE__ */ B("div", { class: "ant-upload-text" }, "上传图片", -1), ee = ["src"], se = /* @__PURE__ */ R({
  name: "PictureField",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(C) {
    const b = "http://filebasex-test.jianjukeji.com/", l = C, { label: x, field: u, required: F, readonly: N, hide: O, eventBus: P, formRecordData: j } = H(l), c = l.options.max || 1, k = l.options.path || "", $ = y(() => {
      const { sizeLimit: e } = l.options;
      return !isNaN(e) && e ? e : 0;
    }), m = y(() => {
      const { suffixes: e } = l.options;
      return e ? e.join(",") : ".png,.jpg,.jpeg";
    }), r = v([]), p = v(!1), w = v(""), f = (e) => {
      let t = e || [];
      t = K(t);
      let n = null;
      t.length !== 0 && (n = [], t = t.map((a) => {
        const i = M(a) ? a : a.name;
        return n.push(i), {
          status: "done",
          uid: q(),
          name: i,
          url: `${b}/${i}`
        };
      })), r.value = t, P.emit("change", { field: u, value: n });
    };
    async function z({ file: e }) {
      if (!T(e))
        return;
      const t = await J(e, k);
      if (!t)
        return;
      const { data: n, endPoint: a, fileName: i } = t;
      A({
        url: a,
        method: "post",
        data: n,
        headers: {
          "Content-Type": "multipart/form-data"
        }
      }).then(
        (d) => {
          if (d.status == 200) {
            const I = {
              status: "done",
              uid: q(),
              name: i,
              url: `${b}/${i}`
            };
            r.value.push(I), f(r.value);
          } else
            s.error("上传失败！");
        },
        (d) => {
          console.log("error :>> ", d), s.error("上传失败！");
        }
      );
    }
    function V({ uid: e }) {
      r.value = r.value.filter((t) => t.uid != e), f(r.value);
    }
    function D({ url: e }) {
      w.value = e, p.value = !0;
    }
    function T(e) {
      if (!e)
        return !1;
      const { name: t, size: n } = e;
      return Q(t, m.value) ? W(n, $.value) ? (s.error(`文件大小不能超过${$.value}KB`), !1) : c && r.value.length >= c ? (s.error(`您最多只能上传${c}个${x.value}，请删除后再继续上传`), !1) : !0 : (s.error(`上传图片只支持${m.value}`), !1);
    }
    return S(() => {
      j[u] && f(j[u]);
    }), (e, t) => {
      const n = _("a-upload"), a = _("a-modal"), i = _("GTField");
      return L(), U(i, {
        label: o(x),
        field: o(u),
        required: o(F),
        hide: o(O)
      }, {
        default: h(() => [
          g(n, {
            name: "file",
            accept: o(m),
            "file-list": o(r),
            disabled: o(N),
            customRequest: z,
            "list-type": "picture-card",
            remove: V,
            onPreview: D
          }, {
            default: h(() => [
              o(r).length < o(c) ? (L(), E("div", Y, [
                g(X, { icon: "PlusOutlined" }),
                Z
              ])) : G("", !0)
            ]),
            _: 1
          }, 8, ["accept", "file-list", "disabled"]),
          g(a, {
            class: "picture-preview-modal",
            title: "查看图片",
            align: "center",
            footer: null,
            visible: o(p),
            onCancel: t[0] || (t[0] = (d) => p.value = !1)
          }, {
            default: h(() => [
              B("img", {
                src: o(w),
                alt: "上传图片"
              }, null, 8, ee)
            ]),
            _: 1
          }, 8, ["visible"])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  se as default
};
