import { defineComponent as W, computed as G, ref as m, reactive as X, watch as Y, onMounted as Z, onUnmounted as ee, resolveComponent as p, openBlock as h, createBlock as w, unref as n, withCtx as d, createVNode as v, isRef as te, createElementBlock as oe, Fragment as ne, createTextVNode as C, createCommentVNode as O, createElementVNode as ae } from "vue";
import le from "../../BaseFields/index.ts";
import ie from "./SubFormTable.vue.ts";
import { cloneDeep as A } from "lodash";
import re from "../../../../apis/formDesign/index.ts";
import { message as ue } from "ant-design-vue";
import { customAlphabet as se } from "../../../../../node_modules/nanoid/index.browser.ts";
const de = { class: "form-table" }, xe = /* @__PURE__ */ W({
  name: "SubForm",
  __name: "index",
  props: {
    options: { type: Object, required: !0 },
    formData: { type: Object, required: !0 }
  },
  setup(U) {
    const S = se("abcdefghijklmnopqrstuvwxyz1234567890", 12), i = U, { label: T, field: b, required: j, readonly: y, hide: z, eventBus: P, formRecordData: V } = le(i), x = i.options.formUid, k = i.options.uniqueKey, g = i.options.autoIndexField, N = i.options.autoIndexPrefix || "", R = i.options.autoIndexSuffix || "", E = G(() => !!i.options.unableDelete), K = G(() => {
      const { size: e, unableAdd: t, max: o } = i.options;
      return t ? !1 : e ? a.value.length < e : o ? a.value.length < o : !0;
    }), $ = m(), _ = m(!1), a = m([]), I = m(), u = X({
      formDef: void 0,
      formName: "",
      formRecordData: void 0,
      parentFormData: void 0
    }), r = m(!1);
    let D = "";
    L();
    const F = (e) => {
      const t = {
        form: x,
        data: []
      }, o = [];
      Array.isArray(e) && (t.data = e.map((l) => (l = A(l), l.uid || (l.uid = S()), o.push(A(l)), delete l.uid, l))), a.value = o, P.emit("change", { field: b, value: t });
    };
    async function L() {
      if (!x)
        return;
      const e = await re.queryFormDesign(x);
      u.formDef = e, I.value = e, u.readonly = y.value, u.formName = x;
    }
    function M({ key: e, record: t }) {
      switch (D = e, e) {
        case "delete":
          J(t);
          break;
        case "edit":
        case "readonly":
          Q(t);
          break;
      }
    }
    async function H() {
      const { state: e, data: t } = await $.value.submit(), o = A(t);
      if (e) {
        if (_.value = !0, k) {
          let l = [o];
          D == "edit" ? l.push(...a.value.filter((s) => s.uid !== o.uid)) : l.push(...a.value);
          const f = l.map((s) => s[k]);
          if (new Set(f).size !== f.length) {
            const { fields: s } = u.formDef, q = s.find((c) => c.name == k) || {};
            ue.error(`${q.label}不能重复！`), _.value = !1;
            return;
          }
        }
        if (D == "edit") {
          let l = a.value.findIndex((f) => f.uid == o.uid);
          a.value.splice(l, 1, o);
        } else
          o.uid = S(), a.value.push(o);
        B(), F(a.value), r.value = !1;
      }
      _.value = !1;
    }
    function B() {
      g && (a.value = a.value.map((e, t) => (N || R ? e[g] = `${N}${t + 1}${R}` : e[g] = t + 1, e)));
    }
    function J(e) {
      a.value = a.value.filter((t) => t.uid != e.uid), B(), F(a.value);
    }
    function Q(e) {
      u.formRecordData = e, r.value = !0;
    }
    return Y(
      () => r.value,
      (e) => {
        e || (u.formRecordData = void 0, D = "");
      }
    ), Z(() => {
      var e;
      V[b] && F((e = V[b]) == null ? void 0 : e.data);
    }), ee(() => {
      F(null);
    }), (e, t) => {
      const o = p("a-button"), l = p("GTForm"), f = p("a-modal"), s = p("SvgIcon"), q = p("GTField");
      return h(), w(q, {
        label: n(T),
        field: n(b),
        required: n(j),
        hide: n(z)
      }, {
        default: d(() => [
          v(f, {
            title: n(T),
            class: "sub-form-modal",
            width: "calc(80% - 270px)",
            height: "600px",
            visible: n(r),
            "onUpdate:visible": t[1] || (t[1] = (c) => te(r) ? r.value = c : null),
            destroyOnClose: ""
          }, {
            footer: d(() => [
              n(y) ? O("", !0) : (h(), oe(ne, { key: 0 }, [
                v(o, {
                  key: "back",
                  onClick: t[0] || (t[0] = (c) => r.value = !1)
                }, {
                  default: d(() => [
                    C("取消")
                  ]),
                  _: 1
                }),
                v(o, {
                  key: "submit",
                  type: "primary",
                  loading: n(_),
                  onClick: H
                }, {
                  default: d(() => [
                    C("确认")
                  ]),
                  _: 1
                }, 8, ["loading"])
              ], 64))
            ]),
            default: d(() => [
              v(l, {
                ref_key: "subForm",
                ref: $,
                options: n(u)
              }, null, 8, ["options"])
            ]),
            _: 1
          }, 8, ["title", "visible"]),
          ae("div", de, [
            n(I) ? (h(), w(ie, {
              key: 0,
              formDef: n(I),
              list: n(a),
              onOperator: M,
              readonly: n(y),
              unableDelete: n(E)
            }, null, 8, ["formDef", "list", "readonly", "unableDelete"])) : O("", !0),
            n(K) ? (h(), w(o, {
              key: 1,
              class: "btn",
              type: "dashed",
              onClick: t[2] || (t[2] = (c) => r.value = !0),
              disabled: n(y)
            }, {
              icon: d(() => [
                v(s, { icon: "PlusOutlined" })
              ]),
              default: d(() => [
                C(" 添加 ")
              ]),
              _: 1
            }, 8, ["disabled"])) : O("", !0)
          ])
        ]),
        _: 1
      }, 8, ["label", "field", "required", "hide"]);
    };
  }
});
export {
  xe as default
};
