import { defineComponent as y, ref as s, onMounted as w, openBlock as b, createBlock as R, unref as n } from "vue";
import _ from "../../../../components/ResourceTable/index.vue.ts";
import l from "../../../../apis/formDesign/index.ts";
import h from "../../../../apis/role/index.ts";
import { message as r } from "ant-design-vue";
const C = /* @__PURE__ */ y({
  name: "FormAuth",
  __name: "index",
  props: {
    formName: { type: String, required: !0 }
  },
  setup(u) {
    const o = u, c = s([]), i = s([]), a = s(!1), d = [
      {
        title: "角色编码",
        dataIndex: "code"
      },
      {
        title: "角色名称",
        dataIndex: "name"
      },
      {
        title: "角色描述",
        dataIndex: "description"
      }
    ], f = async (e, t) => {
      try {
        t ? await l.resourceBind(o.formName, e) : await l.resourceUnbind(o.formName, e), r.success(`${t ? "授权" : "取消授权"}成功！`), await m();
      } catch (g) {
        r.error(g.msg);
      }
    }, p = async () => {
      a.value = !0;
      try {
        const e = await h.queryAllRole();
        c.value = e.list;
      } catch (e) {
        r.error(e.msg);
      } finally {
        a.value = !1;
      }
    }, m = async () => {
      a.value = !0;
      try {
        const e = await l.resourceList(o.formName);
        i.value = e.map((t) => t._id);
      } catch (e) {
        r.error(e.msg);
      } finally {
        a.value = !1;
      }
    };
    return w(async () => {
      await p(), await m();
    }), (e, t) => (b(), R(_, {
      columns: d,
      tableData: n(c),
      tableLoading: n(a),
      onRowClick: f,
      selectedRowKeysFlag: n(i),
      pagination: !1,
      scrollY: 305
    }, null, 8, ["tableData", "tableLoading", "selectedRowKeysFlag"]));
  }
});
export {
  C as default
};
