import { defineComponent as G, ref as r, reactive as V, onMounted as E, resolveComponent as b, openBlock as p, createElementBlock as x, createVNode as _, unref as t, isRef as H, withCtx as h, createElementVNode as U, Fragment as M, renderList as j, createBlock as w, createTextVNode as K, toDisplayString as Q, createCommentVNode as $, nextTick as A } from "vue";
import I from "../../../../components/GTSearch/index.vue.ts";
import J from "../../../../components/GTTable/index.vue.ts";
import { formDef as P, searchFields as W, tableFields as X, tableOperators as Y, recordOperators as Z, quickMap as D } from "./config.ts";
import i from "../../../../apis/dataRule/index.ts";
import { message as u } from "ant-design-vue";
const ee = { class: "rule-max" }, te = { class: "button-max" }, ie = /* @__PURE__ */ G({
  name: "FormRule",
  __name: "index",
  props: {
    formName: { type: String, required: !0 }
  },
  setup(N) {
    const d = N, k = r([]), l = r({ page: 1, size: 10, rule_table: d.formName }), y = r(0), f = r(!1), s = r(!1), g = r(!1), v = r(!0), R = r(""), C = r(), n = V({
      formDef: P,
      formRecordData: {
        rule_table: d.formName
      }
    }), m = async () => {
      f.value = !0;
      try {
        const e = await i.getRules(l.value);
        k.value = e.list, y.value = e.total;
      } catch (e) {
        u.error(e.msg);
      }
      f.value = !1;
    }, T = async () => {
      try {
        const e = await i.getSupportRelation();
        n.formDef.dicts[0].items = e;
      } catch (e) {
        console.log("error :>> ", e);
      }
    }, O = ({ key: e, data: a }) => {
      switch (R.value = e, e) {
        case "add":
          n.formRecordData = {
            rule_table: d.formName
          }, s.value = !0;
          break;
        case "edit":
          n.formRecordData = a, s.value = !0;
          break;
        case "delete":
          S(a);
          break;
      }
    }, z = (e) => {
      v.value = !1, n.formRecordData = { ...n.formRecordData, ...D[e] }, A(() => {
        v.value = !0;
      });
    }, F = async () => {
      g.value = !0;
      const { data: e, state: a } = await C.value.submit();
      if (a)
        try {
          e._id ? await i.updateRule(e._id, e) : await i.addRule(e), u.success("操作成功！"), l.value.page = 1, m(), s.value = !1;
        } catch (c) {
          u.error(c.msg);
        }
      g.value = !1;
    }, S = async ({ _id: e }) => {
      try {
        await i.deleteRule(e), u.success("删除成功！"), l.value.page = 1, m();
      } catch (a) {
        u.error(a.msg);
      }
    }, L = (e) => {
      const a = {
        page: 1,
        size: 10,
        rule_table: d.formName
      };
      e.forEach((c) => {
        a[c.name] = c.value;
      }), l.value = a, m();
    };
    return E(() => {
      m(), T();
    }), (e, a) => {
      const c = b("a-button"), B = b("GTForm"), q = b("a-modal");
      return p(), x("div", ee, [
        _(I, {
          fields: t(W),
          onSearch: L,
          "list-width": 260
        }, null, 8, ["fields"]),
        _(J, {
          fields: t(X),
          data: t(k),
          tableOperators: t(Y),
          recordOperators: t(Z),
          "page-current": t(l).page,
          "onUpdate:pageCurrent": a[0] || (a[0] = (o) => t(l).page = o),
          "page-size": t(l).size,
          "onUpdate:pageSize": a[1] || (a[1] = (o) => t(l).size = o),
          onRecordOperatorClick: O,
          onTableOperatorClick: O,
          total: t(y),
          "y-offset": 280,
          loading: t(f)
        }, null, 8, ["fields", "data", "tableOperators", "recordOperators", "page-current", "page-size", "total", "loading"]),
        _(q, {
          destroyOnClose: "",
          maskClosable: !1,
          getContainer: ".rule-max",
          class: "rule-model",
          open: t(s),
          "onUpdate:open": a[2] || (a[2] = (o) => H(s) ? s.value = o : null),
          style: { width: "600px" },
          onOk: F,
          confirmLoading: t(g),
          title: t(R) == "add" ? "新增规则" : "编辑规则"
        }, {
          default: h(() => [
            U("div", te, [
              (p(!0), x(M, null, j(Object.keys(t(D)), (o) => (p(), w(c, {
                type: "primary",
                key: o,
                onClick: (ae) => z(o)
              }, {
                default: h(() => [
                  K(Q(o), 1)
                ]),
                _: 2
              }, 1032, ["onClick"]))), 128))
            ]),
            t(v) ? (p(), w(B, {
              key: 0,
              ref_key: "formBox",
              ref: C,
              options: t(n)
            }, null, 8, ["options"])) : $("", !0)
          ]),
          _: 1
        }, 8, ["open", "confirmLoading", "title"])
      ]);
    };
  }
});
export {
  ie as default
};
