const e = [
  {
    operator: "=",
    renderer: {
      type: "TextField",
      options: {
        field: "tableTitle",
        label: "表单标题"
      }
    }
  },
  {
    operator: "=",
    renderer: {
      type: "TextField",
      options: {
        field: "tableName",
        label: "表单名称"
      }
    }
  }
], l = [
  { name: "table_title", label: "表单标题" },
  { name: "table_name", label: "表单名称" },
  { name: "version", label: "版本", align: "center", width: 60 },
  { name: "status", label: "运行状态", align: "center", dict: "运行状态", width: 120 },
  {
    name: "update_time",
    type: "datetime",
    label: "更新时间",
    align: "center",
    width: 180
  }
], t = [
  { label: "添加", key: "add", icon: "PlusOutlined" },
  { label: "导入", key: "import", icon: "ImportOutlined" },
  { label: "导出", key: "export", icon: "ExportOutlined" }
], a = [
  { label: "编辑", key: "edit" },
  { label: "删除", key: "delete", color: "#f00", confirm: !0 },
  {
    label: "更多",
    children: [
      { label: "数据", key: "readonly" },
      { label: "规则", key: "rule" },
      { label: "授权", key: "auth" }
    ]
  }
], r = [
  {
    name: "运行状态",
    type: "inline",
    items: [
      {
        label: "未开始",
        value: 0,
        tagColor: "warning",
        tag: !0
      },
      {
        label: "运行中",
        value: 1,
        tagColor: "success",
        tag: !0
      },
      {
        label: "已结束",
        value: -1,
        tagColor: "error",
        tag: !0
      }
    ]
  }
];
export {
  r as Dicts,
  a as recordOperators,
  e as searchFields,
  l as tableFields,
  t as tableOperators
};
