import { defineComponent as j, ref as l, onMounted as G, resolveComponent as w, openBlock as _, createBlock as x, withCtx as p, createVNode as i, unref as t, createElementVNode as H, normalizeClass as q, isRef as b, Suspense as B } from "vue";
import Q from "../../components/GTSearch/index.vue.ts";
import V from "../../components/GTTable/index.vue.ts";
import c from "../../apis/formDesign/index.ts";
import { message as s } from "ant-design-vue";
import { searchFields as A, tableFields as K, tableOperators as M, recordOperators as $, Dicts as J } from "./config.ts";
import P from "../../components/GTSearchTable/index.vue.ts";
import W from "./components/FormDesignEditor/index.vue.ts";
import X from "./components/FormRule/index.vue.ts";
import Y from "./components/FormAuth/index.vue.ts";
const me = /* @__PURE__ */ j({
  name: "FormDesign",
  __name: "index",
  setup(Z) {
    const D = l(), F = l([]), d = l({
      page: 1,
      size: 10
    }), n = l(!1), f = l(!1), g = l(!1), h = l(0), C = l(!1), u = l(""), O = l(), k = l(""), y = l(), m = async () => {
      C.value = !0;
      try {
        const o = await c.searchFormDesign(d.value);
        h.value = o.total, F.value = o.list;
      } catch (o) {
        s.error(o.msg);
      } finally {
        C.value = !1;
      }
    }, z = async (o) => {
      try {
        const e = o.target.files[0];
        if (!E(e.name, ["json"])) {
          s.warning("只能导入json格式文件！");
          return;
        }
        const a = await c.formDesignImport(e), v = (a == null ? void 0 : a.failedIds) || [];
        v.length != 0 ? s.warning(`${v.join(",")}导入失败，其余都已成功导入！`, 10) : s.success("导入成功！"), m();
      } catch (e) {
        s.error(e.msg);
      }
      o.target.value = "";
    }, N = (o) => {
      const e = {
        page: 1,
        size: 10
      };
      o.forEach((a) => {
        e[a.name] = a.value;
      }), d.value = { ...e }, m();
    }, R = ({ key: o, data: e }) => {
      switch (u.value = o, y.value = e, o) {
        case "delete":
          L(e);
          break;
        case "edit":
          U(e);
          break;
        case "readonly":
          n.value = !0;
          break;
        case "rule":
          f.value = !0;
          break;
        case "auth":
          g.value = !0;
          break;
      }
    }, T = ({ key: o, data: e }) => {
      switch (o) {
        case "import":
          D.value.click();
          break;
        case "export":
          I(e);
          break;
        case "add":
          u.value = o, k.value = "添加表单", n.value = !0;
          break;
      }
    };
    async function L({ _id: o }) {
      try {
        await c.deleteFormDesign(o), s.success("删除成功！"), m();
      } catch (e) {
        s.error(e.msg);
      }
    }
    async function U(o) {
      try {
        const e = await c.queryFormDesign(o._id);
        O.value = e, k.value = "编辑表单", n.value = !0;
      } catch (e) {
        s.error(e.msg);
      }
    }
    function E(o, e) {
      if (!o)
        return !1;
      let a = o.substring(o.lastIndexOf(".") + 1, o.length);
      return a = a.toLocaleLowerCase(), e.includes(a);
    }
    function I(o) {
      if (o.length === 0) {
        s.warning("请选择要导出的表单定义！");
        return;
      }
      c.formDesignExport(o);
    }
    return G(() => {
      m();
    }), (o, e) => {
      const a = w("a-modal"), v = w("a-drawer"), S = w("a-card");
      return _(), x(S, {
        title: "表单管理",
        class: "form-design-max"
      }, {
        default: p(() => [
          i(Q, {
            fields: t(A),
            onSearch: N
          }, null, 8, ["fields"]),
          H("input", {
            type: "file",
            ref_key: "import_file",
            ref: D,
            onInput: e[0] || (e[0] = (r) => z(r)),
            accept: ".json",
            style: { display: "none" }
          }, null, 544),
          i(V, {
            data: t(F),
            fields: t(K),
            "table-operators": t(M),
            "record-operators": t($),
            "page-current": t(d).page,
            "onUpdate:pageCurrent": e[1] || (e[1] = (r) => t(d).page = r),
            "page-size": t(d).size,
            "onUpdate:pageSize": e[2] || (e[2] = (r) => t(d).size = r),
            onRefresh: m,
            loading: t(C),
            dicts: t(J),
            total: t(h),
            "allow-select": "",
            "y-offset": 390,
            onRecordOperatorClick: R,
            onTableOperatorClick: T
          }, null, 8, ["data", "fields", "table-operators", "record-operators", "page-current", "page-size", "loading", "dicts", "total"]),
          i(a, {
            destroyOnClose: "",
            maskClosable: !1,
            getContainer: ".form-design-max",
            class: q(["form-design-model", { "form-design-model-data": t(u) === "readonly" }]),
            open: t(n),
            "onUpdate:open": e[4] || (e[4] = (r) => b(n) ? n.value = r : null),
            title: t(k),
            footer: null
          }, {
            default: p(() => [
              t(u) === "readonly" ? (_(), x(B, { key: 0 }, {
                default: p(() => [
                  i(P, {
                    "form-name": t(y)._id
                  }, null, 8, ["form-name"])
                ]),
                _: 1
              })) : (_(), x(W, {
                key: 1,
                open: t(n),
                "onUpdate:open": e[3] || (e[3] = (r) => b(n) ? n.value = r : null),
                onGetList: m,
                type: t(u),
                data: t(O)
              }, null, 8, ["open", "type", "data"]))
            ]),
            _: 1
          }, 8, ["class", "open", "title"]),
          i(v, {
            open: t(f),
            "onUpdate:open": e[5] || (e[5] = (r) => b(f) ? f.value = r : null),
            rootClassName: "form-design-rule",
            getContainer: ".form-design-max",
            title: "资源权限规则",
            placement: "right",
            destroyOnClose: "",
            maskClosable: !1
          }, {
            default: p(() => {
              var r;
              return [
                i(X, {
                  formName: (r = t(y)) == null ? void 0 : r._id
                }, null, 8, ["formName"])
              ];
            }),
            _: 1
          }, 8, ["open"]),
          i(a, {
            destroyOnClose: "",
            maskClosable: !1,
            getContainer: ".form-design-max",
            class: "role-model",
            open: t(g),
            "onUpdate:open": e[6] || (e[6] = (r) => b(g) ? g.value = r : null),
            title: "授权角色",
            style: { width: "800px" },
            footer: null
          }, {
            default: p(() => {
              var r;
              return [
                i(Y, {
                  formName: (r = t(y)) == null ? void 0 : r._id
                }, null, 8, ["formName"])
              ];
            }),
            _: 1
          }, 8, ["open"])
        ]),
        _: 1
      });
    };
  }
});
export {
  me as default
};
