import { defineComponent as O, ref as p, watch as T, resolveComponent as c, openBlock as w, createElementBlock as P, createElementVNode as i, normalizeClass as x, unref as e, createVNode as t, withCtx as s, createBlock as N, createCommentVNode as R, withKeys as $, createTextVNode as S, pushScopeId as B, popScopeId as D } from "vue";
import { STATUS as I } from "../../types.ts";
import L from "../../../../apis/login/index.ts";
import { message as V } from "ant-design-vue";
import { LoginMode as _, loginModeJson as U } from "./config.ts";
import { cloneDeep as H } from "lodash";
import { useRouter as K } from "../../../../../node_modules/vue-router/dist/vue-router.ts";
const z = (f) => (B("data-v-2abdafa9"), f = f(), D(), f), F = { class: "login-wrapper" }, G = /* @__PURE__ */ z(() => /* @__PURE__ */ i("div", { class: "title" }, "欢迎登录", -1)), J = { class: "body" }, W = { class: "model_box" }, j = { class: "submit" }, q = { class: "link-wrapper" }, ne = /* @__PURE__ */ O({
  __name: "index",
  emits: ["update:status"],
  setup(f, { emit: A }) {
    const y = A, E = K(), h = p(), v = p(!1), r = p(_.USERNAME), a = p(), C = p();
    T(
      r,
      (n) => {
        a.value = H(U[n].formData), C.value = U[n].rules;
      },
      {
        immediate: !0
      }
    );
    const M = async () => {
      try {
        v.value = !0;
        const { username: n, password: o } = a.value;
        let u = await L.login(n, o);
        const { access_token: d, refresh_token: m, user_id: g } = u;
        localStorage.setItem("access_token", d), localStorage.setItem("refresh_token", m), localStorage.setItem("user_id", g), E.push("/");
      } catch (n) {
        V.error(n.msg);
      } finally {
        v.value = !1;
      }
    }, b = () => {
      var n;
      console.log("router :>> ", E), (n = h.value) == null || n.validate().then(() => {
        M();
      }).catch((o) => {
        console.log("error :>> ", o);
      });
    };
    return (n, o) => {
      const u = c("svg-icon"), d = c("a-input"), m = c("a-form-item"), g = c("a-form"), k = c("a-button");
      return w(), P("div", F, [
        G,
        i("div", J, [
          i("div", W, [
            i("div", {
              class: x(["model_item", "left", { active: e(r) === e(_).USERNAME }]),
              onClick: o[0] || (o[0] = (l) => r.value = e(_).USERNAME)
            }, " 用户名登录 ", 2),
            i("div", {
              class: x(["model_item", { active: e(r) === e(_).PHONE }]),
              onClick: o[1] || (o[1] = (l) => r.value = e(_).PHONE)
            }, " 手机号登录 ", 2)
          ]),
          t(g, {
            autocomplete: "off",
            model: e(a),
            rules: e(C),
            ref_key: "loginRef",
            ref: h
          }, {
            default: s(() => [
              e(r) === "username" ? (w(), N(m, {
                key: 0,
                name: "username"
              }, {
                default: s(() => [
                  t(d, {
                    value: e(a).username,
                    "onUpdate:value": o[2] || (o[2] = (l) => e(a).username = l),
                    class: "input-item",
                    placeholder: "用户名",
                    allowClear: ""
                  }, {
                    prefix: s(() => [
                      t(u, { icon: "UserOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              })) : R("", !0),
              e(r) === "phone" ? (w(), N(m, {
                key: 1,
                name: "phone"
              }, {
                default: s(() => [
                  t(d, {
                    value: e(a).phone,
                    "onUpdate:value": o[3] || (o[3] = (l) => e(a).phone = l),
                    class: "input-phone",
                    allClear: "",
                    placeholder: "请输入手机号"
                  }, {
                    prefix: s(() => [
                      t(u, { icon: "PhoneOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              })) : R("", !0),
              t(m, { name: "password" }, {
                default: s(() => [
                  t(d, {
                    type: "password",
                    value: e(a).password,
                    "onUpdate:value": o[4] || (o[4] = (l) => e(a).password = l),
                    class: "input-item",
                    placeholder: "密码",
                    allowClear: "",
                    onKeydown: $(b, ["enter"])
                  }, {
                    prefix: s(() => [
                      t(u, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              })
            ]),
            _: 1
          }, 8, ["model", "rules"]),
          i("div", j, [
            t(k, {
              type: "primary",
              block: "",
              onClick: b,
              class: "input-item",
              loading: e(v)
            }, {
              default: s(() => [
                S(" 登录 ")
              ]),
              _: 1
            }, 8, ["loading"])
          ]),
          i("div", q, [
            t(k, {
              type: "link",
              onClick: o[5] || (o[5] = (l) => y("update:status", e(I).REGISTER))
            }, {
              default: s(() => [
                S("注册账号")
              ]),
              _: 1
            }),
            t(k, {
              class: "btn-forget-passwd",
              type: "link",
              onClick: o[6] || (o[6] = (l) => y("update:status", e(I).RESET_PASSWD))
            }, {
              default: s(() => [
                S("忘记密码")
              ]),
              _: 1
            })
          ])
        ])
      ]);
    };
  }
});
export {
  ne as default
};
