import { defineComponent as h, ref as s, onMounted as w, openBlock as _, createElementBlock as b, createVNode as I, unref as c } from "vue";
import x from "../../../../../components/ResourceTable/index.vue.ts";
import n from "../../../../../apis/role/index.ts";
import k from "../../../../../apis/resource/index.ts";
import { message as o } from "ant-design-vue";
const L = { class: "authorApi-box" }, z = /* @__PURE__ */ h({
  __name: "index",
  props: {
    currentRoleItem: { type: Object, required: !0 }
  },
  setup(d) {
    let m = s(0), r = s(!1);
    const u = s([]), l = s([]), i = d, p = [
      {
        title: "接口名称",
        dataIndex: "name"
      },
      {
        title: "接口地址",
        dataIndex: "uri"
      },
      {
        title: "所属分组",
        dataIndex: "groupname"
      },
      {
        title: "接口描述",
        dataIndex: "description"
      }
    ], f = async () => {
      r.value = !0;
      try {
        const e = await k.queryResourceList({ type: "api" });
        u.value = e.list;
      } catch ({ msg: e }) {
        o.error(e);
      } finally {
        r.value = !1;
      }
    }, y = async () => {
      const { _id: e } = i.currentRoleItem;
      try {
        let t = await n.authResource(e, { type: "api" });
        l.value = t.map((a) => a._id);
      } catch {
        o.error("获取角色授权接口失败");
      }
    };
    w(async () => {
      await f(), await y();
    });
    const R = async (e, t) => {
      const { _id: a } = i.currentRoleItem;
      t ? await g(a, e) : await v(a, e);
    }, g = async (e, t) => {
      r.value = !0;
      try {
        await n.authorizeResource(e, t), o.success("授权成功"), l.value.push(...t);
      } catch ({ msg: a }) {
        o.error(a);
      } finally {
        r.value = !1;
      }
    }, v = async (e, t) => {
      r.value = !0;
      try {
        await n.revokeResource(e, t), o.success("取消授权成功"), l.value = l.value.filter((a) => !t.includes(a));
      } catch ({ msg: a }) {
        o.error(a);
      } finally {
        r.value = !1;
      }
    };
    return (e, t) => (_(), b("div", L, [
      I(x, {
        currentRoleItem: e.currentRoleItem,
        columns: p,
        tableData: c(u),
        tableLoading: c(r),
        onRowClick: R,
        total: c(m),
        selectedRowKeysFlag: c(l),
        pagination: !1,
        scrollY: 240
      }, null, 8, ["currentRoleItem", "tableData", "tableLoading", "total", "selectedRowKeysFlag"])
    ]));
  }
});
export {
  z as default
};
