import { defineComponent as q, ref as l, computed as G, onMounted as H, resolveComponent as _, openBlock as m, createElementBlock as L, createVNode as y, unref as o, createBlock as R, createCommentVNode as b, isRef as A, withCtx as D } from "vue";
import { searchFields as E, tableFields as O, recordOperators as M, tableOperators as j } from "./config.ts";
import U from "../../../../../components/GTTable/index.vue.ts";
import C from "../../../../../apis/role/index.ts";
import { message as h } from "ant-design-vue";
import V from "./ModifyResource.vue.ts";
import $ from "./Rule.vue.ts";
const J = {
  class: "resources-box",
  ref: "resourcesBox"
}, ee = /* @__PURE__ */ q({
  __name: "index",
  props: {
    currentRoleItem: { type: Object, required: !0 }
  },
  setup(T) {
    const u = T, v = l([]), f = l([]);
    let a = l(!1);
    const n = l(!1);
    let p = l(""), s = l(""), i = {
      tableTitle: "",
      tableName: ""
    };
    const d = async (e) => {
      a.value = !0;
      try {
        const r = await C.getRoleFormList(e);
        v.value = r, f.value = v.value.filter(
          ({ table_title: t, table_name: c }) => t.includes(i.tableTitle) && c.includes(i.tableName)
        );
      } catch ({ msg: r }) {
        h.error(r);
      } finally {
        a.value = !1;
      }
    }, g = G(() => f.value.map((e) => e._id)), N = (e) => {
      i = {
        tableTitle: "",
        tableName: ""
      }, e.length != 0 && e.forEach((t) => {
        i[t.name] = t.value;
      });
      const { _id: r } = u.currentRoleItem;
      d(r);
    }, w = (e) => {
      const { key: r } = e;
      if (r)
        switch (r) {
          case "authorization":
            p.value = "授权表单", s.value = r, n.value = !0;
            break;
        }
    }, z = (e) => {
      if (!e)
        return;
      const { key: r, data: t } = e;
      switch (r) {
        case "rule":
          p.value = "修改规则", s.value = r, n.value = !0, S(t);
          break;
        case "cancelAuthorization":
          B(t);
          break;
      }
    }, B = async (e) => {
      const { _id: r } = e, { _id: t } = u.currentRoleItem;
      a.value = !0;
      try {
        await C.unbindForm(t, [r]), h.success("取消授权成功"), d(t);
      } catch ({ msg: c }) {
        h.error(c);
      } finally {
        a.value = !1;
      }
    }, F = () => {
      const { _id: e } = u.currentRoleItem;
      s.value == "authorization" && d(e);
    };
    let I = l(""), k = l("");
    const S = (e) => {
      const { _id: r, table_name: t } = e;
      I.value = r, k.value = t;
    };
    return H(() => {
      const { _id: e } = u.currentRoleItem;
      d(e);
    }), (e, r) => {
      const t = _("GTSearch"), c = _("a-modal");
      return m(), L("div", J, [
        y(t, {
          fields: o(E),
          onSearch: N
        }, null, 8, ["fields"]),
        o(O).length != 0 ? (m(), R(U, {
          key: 0,
          data: o(f),
          fields: o(O),
          recordOperators: o(M),
          onRecordOperatorClick: z,
          tableOperators: o(j),
          onTableOperatorClick: w,
          loading: o(a),
          allowSelect: !1,
          yOffset: 325
        }, null, 8, ["data", "fields", "recordOperators", "tableOperators", "loading"])) : b("", !0),
        y(c, {
          open: o(n),
          "onUpdate:open": r[0] || (r[0] = (x) => A(n) ? n.value = x : null),
          title: o(p),
          destroyOnClose: "",
          footer: null,
          width: 1e3,
          getContainer: () => e.$refs.resourcesBox,
          onCancel: F
        }, {
          default: D(() => [
            o(s) === "authorization" ? (m(), R(V, {
              key: 0,
              currentRoleItem: e.currentRoleItem,
              resourcesIds: o(g)
            }, null, 8, ["currentRoleItem", "resourcesIds"])) : b("", !0),
            o(s) === "rule" ? (m(), R($, {
              key: 1,
              currentRoleItem: e.currentRoleItem,
              ruleResourceId: o(I),
              ruleResourceTableName: o(k)
            }, null, 8, ["currentRoleItem", "ruleResourceId", "ruleResourceTableName"])) : b("", !0)
          ]),
          _: 1
        }, 8, ["open", "title", "getContainer"])
      ], 512);
    };
  }
});
export {
  ee as default
};
